PF-build.sh 52 KB

12345678910111213141516171819202122232425262728293031323334353637383940414243444546474849505152535455565758596061626364656667686970717273747576777879808182838485868788899091929394959697989910010110210310410510610710810911011111211311411511611711811912012112212312412512612712812913013113213313413513613713813914014114214314414514614714814915015115215315415515615715815916016116216316416516616716816917017117217317417517617717817918018118218318418518618718818919019119219319419519619719819920020120220320420520620720820921021121221321421521621721821922022122222322422522622722822923023123223323423523623723823924024124224324424524624724824925025125225325425525625725825926026126226326426526626726826927027127227327427527627727827928028128228328428528628728828929029129229329429529629729829930030130230330430530630730830931031131231331431531631731831932032132232332432532632732832933033133233333433533633733833934034134234334434534634734834935035135235335435535635735835936036136236336436536636736836937037137237337437537637737837938038138238338438538638738838939039139239339439539639739839940040140240340440540640740840941041141241341441541641741841942042142242342442542642742842943043143243343443543643743843944044144244344444544644744844945045145245345445545645745845946046146246346446546646746846947047147247347447547647747847948048148248348448548648748848949049149249349449549649749849950050150250350450550650750850951051151251351451551651751851952052152252352452552652752852953053153253353453553653753853954054154254354454554654754854955055155255355455555655755855956056156256356456556656756856957057157257357457557657757857958058158258358458558658758858959059159259359459559659759859960060160260360460560660760860961061161261361461561661761861962062162262362462562662762862963063163263363463563663763863964064164264364464564664764864965065165265365465565665765865966066166266366466566666766866967067167267367467567667767867968068168268368468568668768868969069169269369469569669769869970070170270370470570670770870971071171271371471571671771871972072172272372472572672772872973073173273373473573673773873974074174274374474574674774874975075175275375475575675775875976076176276376476576676776876977077177277377477577677777877978078178278378478578678778878979079179279379479579679779879980080180280380480580680780880981081181281381481581681781881982082182282382482582682782882983083183283383483583683783883984084184284384484584684784884985085185285385485585685785885986086186286386486586686786886987087187287387487587687787887988088188288388488588688788888989089189289389489589689789889990090190290390490590690790890991091191291391491591691791891992092192292392492592692792892993093193293393493593693793893994094194294394494594694794894995095195295395495595695795895996096196296396496596696796896997097197297397497597697797897998098198298398498598698798898999099199299399499599699799899910001001100210031004100510061007100810091010101110121013101410151016101710181019102010211022102310241025102610271028102910301031103210331034103510361037103810391040
  1. #!/bin/bash
  2. # This bash script is used to compile automatically the Prusa firmware with a dedicated build environment and settings
  3. #
  4. # Supported OS: Windows 10, Linux64 bit
  5. # Beta OS: Linux32 bit
  6. #
  7. # Linux:
  8. #
  9. # Windows:
  10. # To execute this script you gonna need few things on your Windows machine
  11. #
  12. # Linux Subsystem Ubuntu
  13. # 1. Follow these instructions
  14. # 2. Open Ubuntu bash and get latest updates with 'apt-get update'
  15. # 3. Install zip with 'apt-get install zip'
  16. # 4. Install python3 with 'apt-get install python3'
  17. # 5. Add command 'ln -sf /usr/bin/python3.5 /usr/bin/python' to link python3 to python.
  18. # Do not install 'python' as python 2.x has end of life see https://pythonclock.org/
  19. # 6. Add at top of ~/.bashrc following lines by using 'sudo nano ~/.bashrc'
  20. #
  21. # export OS="Linux"
  22. # export JAVA_TOOL_OPTIONS="-Djava.net.preferIPv4Stack=true"
  23. # export GPG_TTY=$(tty)
  24. #
  25. # and confirm them. Restart Ubuntu bash
  26. #
  27. # Or GIT-BASH
  28. # 1. Download and install the correct (64bit or 32bit) Git version https://git-scm.com/download/win
  29. # 2. Also follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058
  30. # 3. Download and install 7z-zip from its official website.
  31. # By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case.
  32. # 4. Run git Bash under Administrator privilege and navigate to the directory /c/Program Files/Git/mingw64/bin,
  33. # you can run the command ln -s /c/Program Files/7-Zip/7z.exe zip.exe
  34. #
  35. # Useful things to edit and compare your custom Firmware
  36. # 1. Download and install current and correct (64bit or 32bit) Notepad++ version https://notepad-plus-plus.org/download
  37. # 2. Another great tool to compare your custom mod and stock firmware is WinMerge http://winmerge.org/downloads/?lang=en
  38. #
  39. # Example for MK3: open git bash and change to your Firmware directory
  40. # <username>@<machine name> MINGW64 /<drive>/path
  41. # bash build.sh 1_75mm_MK3-EINSy10a-E3Dv6full
  42. #
  43. # Example for MK25: open git bash and change to your directory
  44. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware/MK3
  45. # bash build.sh 1_75mm_MK25-RAMBo13a-E3Dv6full
  46. #
  47. # The compiled hex files can be found in the folder above like from the example
  48. # gussner@WIN01 MINGW64 /d/Data/Prusa-Firmware
  49. # FW351-Build1778-1_75mm_MK25-RAMBo13a-E3Dv6full.hex
  50. #
  51. # Why make Arduino IDE portable?
  52. # To have a distinguished Prusa Firmware build environment I decided to use Arduino IDE in portable mode.
  53. # - Changes made to other Arduino instances do not change anything in this build environment.
  54. # By default Arduino IDE uses "users" and shared library folders which is useful as soon you update the Software.
  55. # But in this case we need a stable and defined build environment, so keep it separated it kind of important.
  56. # Some may argue that this is only used by a script, BUT as soon someone accidentally or on purpose starts Arduino IDE
  57. # it will use the default Arduino IDE folders and so can corrupt the build environment.
  58. #
  59. # Version: 1.2.0-Build_47
  60. # Change log:
  61. # 12 Jan 2019, 3d-gussner, Fixed "compiler.c.elf.flags=-w -Os -Wl,-u,vfprintf -lprintf_flt -lm -Wl,--gc-sections" in 'platform.txt'
  62. # 16 Jan 2019, 3d-gussner, Build_2, Added development check to modify 'Configuration.h' to prevent unwanted LCD messages that Firmware is unknown
  63. # 17 Jan 2019, 3d-gussner, Build_3, Check for OS Windows or Linux and use the right build environment
  64. # 10 Feb 2019, ropaha, Pull Request, Select variant from list while using build.sh
  65. # 10 Feb 2019, ropaha, change FW_DEV_VERSION automatically depending on FW_VERSION RC/BETA/ALPHA
  66. # 10 Feb 2019, 3d-gussner, 1st tests with English only
  67. # 10 Feb 2019, ropaha, added compiling of all variants and English only
  68. # 10 Feb 2019, 3d-gussner, Set OUTPUT_FOLDER for hex files
  69. # 11 Feb 2019, 3d-gussner/ropaha, Minor changes and fixes
  70. # 11 Feb 2019, 3d-gussner, Ready for RC
  71. # 12 Feb 2019, 3d-gussner, Check if wget and zip are installed. Thanks to Bernd to point it out
  72. # 12 Feb 2019, 3d-gussner, Changed OS check to OSTYPE as it is not supported on Ubuntu
  73. # Also added different BUILD_ENV folders depending on OS used so Windows
  74. # Users can use git-bash AND Windows Linux Subsystems at the same time
  75. # Cleanup compiler flags is only depends on OS version.
  76. # 12 Feb 2019, 3d-gussner, Added additional OSTYPE check
  77. # 15 feb 2019, 3d-gussner, Added zip files for miniRAMbo multi language hex files
  78. # 15 Feb 2019, 3d-gussner, Added more checks if
  79. # Compiled Hex-files
  80. # Configuration_prusa.h
  81. # language build files
  82. # multi language firmware files exist and clean them up
  83. # 15 Feb 2019, 3d-gussner, Fixed selection GOLD/UNKNOWN DEV_STATUS for ALL variants builds, so you have to choose only once
  84. # 15 Feb 2019, 3d-gussner, Added some colored output
  85. # 15 Feb 2019, 3d-gussner, troubleshooting and minor fixes
  86. # 16 Feb 2019, 3d-gussner, Script can be run using arguments
  87. # $1 = variant, example "1_75mm_MK3-EINSy10a-E3Dv6full.h" at this moment it is not possible to use ALL
  88. # $2 = multi language OR English only [ALL/EN_ONLY]
  89. # $3 = development status [GOLD/RC/BETA/ALPHA/DEVEL/DEBUG]
  90. # If one argument is wrong a list of valid one will be shown
  91. # 13 Mar 2019, 3d-gussner, MKbel updated the Linux build environment to version 1.0.2 with an Fix maximum firmware flash size.
  92. # So did I
  93. # 11 Jul 2019, deliopoulos,Updated to v1.0.6 as Prusa needs a new board definition for Firmware 3.8.x86_64
  94. # - Split the Download of Windows Arduino IDE 1.8.5 and Prusa specific part
  95. # --> less download volume needed and saves some time
  96. #
  97. # 13 Jul 2019, deliopoulos,Splitting of Arduino IDE and Prusa parts also for Linux64
  98. # 13 Jul 2019, 3d-gussner, Added Linux 32-bit version (untested yet)
  99. # MacOS could be added in future if needs
  100. # 14 Jul 2019, 3d-gussner, Update preferences and make it really portable
  101. # 15 Jul 2019, 3d-gussner, New PF-build-env GitHub branch
  102. # 16 Jul 2019, 3d-gussner, New Arduino_boards GitHub fork
  103. # 17 Jul 2019, 3d-gussner, Final tests under Windows 10 and Linux Subsystem for Windows
  104. # 18 Jul 2019, 3d-gussner, Added python check
  105. # 18 Jul 2019, deliopoulos, No need more for changing 'platform.txt' file as it comes with the Arduino Boards.
  106. # 18 Jul 2019, deliopoulos, Modified 'PF_BUILD_FILE_URL' to use 'BUILD_ENV' variable
  107. # 22 Jul 2019, 3d-gussner, Modified checks to check folder and/or installation output exists.
  108. # 22 Jul 2019, 3d-gussner, Added check if Arduino IDE 1.8.5 boards have been updated
  109. # 22 Jul 2019, 3d-gussner, Changed exit numbers 1-13 for prepare build env 21-28 for prepare compiling 31-36 compiling
  110. # 22 Jul 2019, 3d-gussner, Changed BOARD_URL to DRracers repository after he pulled my PR https://github.com/DRracer/Arduino_Boards/pull/1
  111. # 23 Jul 2019, 3d-gussner, Changed Build-env path to "PF-build-dl" as requested in PR https://github.com/prusa3d/Prusa-Firmware/pull/2028
  112. # Changed Hex-files folder to PF-build-hex as requested in PR
  113. # 23 Jul 2019, 3d-gussner, Added Finding OS version routine so supporting new OS should get easier
  114. # 26 Jul 2019, 3d-gussner, Change JSON repository to prusa3d after PR https://github.com/prusa3d/Arduino_Boards/pull/1 was merged
  115. # 23 Sep 2019, 3d-gussner, Prepare PF-build.sh for coming Prusa3d/Arduino_Boards version 1.0.2 Pull Request
  116. # 17 Oct 2019, 3d-gussner, Changed folder and check file names to have separated build environments depending on Arduino IDE version and
  117. # board-versions.
  118. # 15 Dec 2019, 3d-gussner, Prepare for switch to Prusa3d/PF-build-env repository
  119. # 15 Dec 2019, 3d-gussner, Fix Arduino user preferences for the chosen board.
  120. # 17 Dec 2019, 3d-gussner, Fix "timer0_fract = 0" warning by using Arduino_boards v1.0.3
  121. # 28 Apr 2020, 3d-gussner, Added RC3 detection
  122. # 03 May 2020, deliopoulos, Accept all RCx as RC versions
  123. # 05 May 2020, 3d-gussner, Make a copy of `not_tran.txt`and `not_used.txt` as `not_tran_$VARIANT.txt`and `not_used_$VARIANT.txt`
  124. # After compiling All multi-language variants it makes it easier to find missing or unused translations.
  125. # 12 May 2020, DRracer , Cleanup double MK2/s MK25/s `not_tran` and `not_used` files
  126. # 13 May 2020, leptun , If cleanup files do not exist don't try to.
  127. # 01 Oct 2020, 3d-gussner, Bug fix if using argument EN_ONLY. Thank to @leptun for pointing out.
  128. # Change Build number to script commits 'git rev-list --count HEAD PF-build.sh'
  129. # 02 Oct 2020, 3d-gussner, Add UNKNOWN as argument option
  130. # 05 Oct 2020, 3d-gussner, Disable pause and warnings using command line with all needed arguments
  131. # Install needed apps under linux if needed.
  132. # Clean PF-Firmware build when changing git branch
  133. # 02 Nov 2020, 3d-gussner, Check for "gawk" on Linux
  134. # Add argument to change build number automatically to current commit or define own number
  135. # Update exit numbers 1-13 for prepare build env 21-29 for prepare compiling 30-36 compiling
  136. # 08 Jan 2021, 3d-gussner, Comment out 'sudo' auto installation
  137. # Add '-?' '-h' help option
  138. # 27 Jan 2021, 3d-gussner, Add `-c`, `-p` and `-n` options
  139. # 12 Feb 2021, 3d-gussner, Add MK404-build.sh
  140. # 13 Feb 2021, 3d-gussner, Indentations
  141. # 13 Feb 2021, 3d-gussner, MK404 improvements like "flash" MK3, MK3S languages files to MK404 xflash.
  142. # 27 Feb 2021, 3d-gussner, Add './lang-community.sh' and update exits
  143. # 03 May 2021, 3d-gussner, Update exit numbers
  144. # 01-14 prepare build env
  145. # 21-32 prepare compiling
  146. # 41-47 compiling
  147. # 51-54 cleanup
  148. # 61-62 MK404
  149. # 03 May 2021, 3d-gussner, Update documentation and change version to v1.2.0
  150. #### Start check if OSTYPE is supported
  151. OS_FOUND=$( command -v uname)
  152. case $( "${OS_FOUND}" | tr '[:upper:]' '[:lower:]') in
  153. linux*)
  154. TARGET_OS="linux"
  155. ;;
  156. msys*|cygwin*|mingw*)
  157. # or possible 'bash on windows'
  158. TARGET_OS='windows'
  159. ;;
  160. nt|win*)
  161. TARGET_OS='windows'
  162. ;;
  163. *)
  164. TARGET_OS='unknown'
  165. ;;
  166. esac
  167. # Windows
  168. if [ $TARGET_OS == "windows" ]; then
  169. if [ $(uname -m) == "x86_64" ]; then
  170. echo "$(tput setaf 2)Windows 64-bit found$(tput sgr0)"
  171. Processor="64"
  172. elif [ $(uname -m) == "i386" ]; then
  173. echo "$(tput setaf 2)Windows 32-bit found$(tput sgr0)"
  174. Processor="32"
  175. else
  176. echo "$(tput setaf 1)Unsupported OS: Windows $(uname -m)"
  177. echo "Please refer to the notes of build.sh$(tput sgr0)"
  178. exit 1
  179. fi
  180. # Linux
  181. elif [ $TARGET_OS == "linux" ]; then
  182. if [ $(uname -m) == "x86_64" ]; then
  183. echo "$(tput setaf 2)Linux 64-bit found$(tput sgr0)"
  184. Processor="64"
  185. elif [[ $(uname -m) == "i386" || $(uname -m) == "i686" ]]; then
  186. echo "$(tput setaf 2)Linux 32-bit found$(tput sgr0)"
  187. Processor="32"
  188. else
  189. echo "$(tput setaf 1)Unsupported OS: Linux $(uname -m)"
  190. echo "Please refer to the notes of build.sh$(tput sgr0)"
  191. exit 1
  192. fi
  193. else
  194. echo "$(tput setaf 1)This script doesn't support your Operating system!"
  195. echo "Please use Linux 64-bit or Windows 10 64-bit with Linux subsystem / git-bash"
  196. echo "Read the notes of build.sh$(tput sgr0)"
  197. exit 1
  198. fi
  199. sleep 2
  200. #### End check if OSTYPE is supported
  201. #### Prepare bash environment and check if wget, zip and other needed things are available
  202. # Check wget
  203. if ! type wget > /dev/null; then
  204. echo "$(tput setaf 1)Missing 'wget' which is important to run this script"
  205. echo "Please follow these instructions https://gist.github.com/evanwill/0207876c3243bbb6863e65ec5dc3f058 to install wget$(tput sgr0)"
  206. exit 2
  207. fi
  208. # Check for zip
  209. if ! type zip > /dev/null; then
  210. if [ $TARGET_OS == "windows" ]; then
  211. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  212. echo "Download and install 7z-zip from its official website https://www.7-zip.org/"
  213. echo "By default, it is installed under the directory /c/Program Files/7-Zip in Windows 10 as my case."
  214. echo "Run git Bash under Administrator privilege and"
  215. echo "navigate to the directory /c/Program Files/Git/mingw64/bin,"
  216. echo "you can run the command $(tput setaf 2)ln -s /c/Program Files/7-Zip/7z.exe zip.exe$(tput sgr0)"
  217. exit 3
  218. elif [ $TARGET_OS == "linux" ]; then
  219. echo "$(tput setaf 1)Missing 'zip' which is important to run this script"
  220. echo "install it with the command $(tput setaf 2)'sudo apt-get install zip'$(tput sgr0)"
  221. #sudo apt-get update && apt-get install zip
  222. exit 3
  223. fi
  224. fi
  225. # Check python ... needed during language build
  226. if ! type python > /dev/null; then
  227. if [ $TARGET_OS == "windows" ]; then
  228. echo "$(tput setaf 1)Missing 'python3' which is important to run this script"
  229. exit 4
  230. elif [ $TARGET_OS == "linux" ]; then
  231. echo "$(tput setaf 1)Missing 'python' which is important to run this script"
  232. echo "As Python 2.x will not be maintained from 2020 please,"
  233. echo "install it with the command $(tput setaf 2)'sudo apt-get install python3'."
  234. echo "Check which version of Python3 has been installed using 'ls /usr/bin/python3*'"
  235. echo "Use 'sudo ln -sf /usr/bin/python3.x /usr/bin/python' (where 'x' is your version number) to make it default.$(tput sgr0)"
  236. #sudo apt-get update && apt-get install python3 && ln -sf /usr/bin/python3 /usr/bin/python
  237. exit 4
  238. fi
  239. fi
  240. # Check gawk ... needed during language build
  241. if ! type gawk > /dev/null; then
  242. if [ $TARGET_OS == "linux" ]; then
  243. echo "$(tput setaf 1)Missing 'gawk' which is important to run this script"
  244. echo "install it with the command $(tput setaf 2)'sudo apt-get install gawk'."
  245. #sudo apt-get update && apt-get install gawk
  246. exit 5
  247. fi
  248. fi
  249. #### End prepare bash / Linux environment
  250. #### Set build environment
  251. ARDUINO_ENV="1.8.5"
  252. BUILD_ENV="1.0.6"
  253. BOARD="prusa_einsy_rambo"
  254. BOARD_PACKAGE_NAME="PrusaResearch"
  255. BOARD_VERSION="1.0.3"
  256. #BOARD_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/package_prusa3d_index.json"
  257. BOARD_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/package_prusa3d_index.json"
  258. BOARD_FILENAME="prusa3dboards"
  259. #BOARD_FILE_URL="https://raw.githubusercontent.com/3d-gussner/Arduino_Boards/Prusa_Merge_v1.0.3/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  260. BOARD_FILE_URL="https://raw.githubusercontent.com/prusa3d/Arduino_Boards/master/IDE_Board_Manager/prusa3dboards-1.0.3.tar.bz2"
  261. #PF_BUILD_FILE_URL="https://github.com/3d-gussner/PF-build-env-1/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  262. PF_BUILD_FILE_URL="https://github.com/prusa3d/PF-build-env/releases/download/$BUILD_ENV-WinLin/PF-build-env-WinLin-$BUILD_ENV.zip"
  263. LIB="PrusaLibrary"
  264. SCRIPT_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  265. # List few useful data
  266. echo
  267. echo "Script path :" $SCRIPT_PATH
  268. echo "OS :" $OS
  269. echo "OS type :" $TARGET_OS
  270. echo ""
  271. echo "Arduino IDE :" $ARDUINO_ENV
  272. echo "Build env :" $BUILD_ENV
  273. echo "Board :" $BOARD
  274. echo "Package name:" $BOARD_PACKAGE_NAME
  275. echo "Board v. :" $BOARD_VERSION
  276. echo "Specific Lib:" $LIB
  277. echo ""
  278. #### Start prepare building environment
  279. #Check if build exists and creates it if not
  280. if [ ! -d "../PF-build-dl" ]; then
  281. mkdir ../PF-build-dl || exit 6
  282. fi
  283. cd ../PF-build-dl || exit 7
  284. BUILD_ENV_PATH="$( cd "$(dirname "$0")" ; pwd -P )"
  285. # Check if PF-build-env-<version> exists and downloads + creates it if not
  286. # The build environment is based on the supported Arduino IDE portable version with some changes
  287. if [ ! -d "../PF-build-env-$BUILD_ENV" ]; then
  288. echo "$(tput setaf 6)PF-build-env-$BUILD_ENV is missing ... creating it now for you$(tput sgr 0)"
  289. mkdir ../PF-build-env-$BUILD_ENV
  290. sleep 5
  291. fi
  292. # Download and extract supported Arduino IDE depending on OS
  293. # Windows
  294. if [ $TARGET_OS == "windows" ]; then
  295. if [ ! -f "arduino-$ARDUINO_ENV-windows.zip" ]; then
  296. echo "$(tput setaf 6)Downloading Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  297. sleep 2
  298. wget https://downloads.arduino.cc/arduino-$ARDUINO_ENV-windows.zip || exit 8
  299. echo "$(tput sgr 0)"
  300. fi
  301. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  302. echo "$(tput setaf 6)Unzipping Windows 32/64-bit Arduino IDE portable...$(tput setaf 2)"
  303. sleep 2
  304. unzip arduino-$ARDUINO_ENV-windows.zip -d ../PF-build-env-$BUILD_ENV || exit 9
  305. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  306. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  307. echo "$(tput sgr0)"
  308. fi
  309. fi
  310. # Linux
  311. if [ $TARGET_OS == "linux" ]; then
  312. # 32 or 64 bit version
  313. if [ ! -f "arduino-$ARDUINO_ENV-linux$Processor.tar.xz" ]; then
  314. echo "$(tput setaf 6)Downloading Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  315. sleep 2
  316. wget --no-check-certificate https://downloads.arduino.cc/arduino-$ARDUINO_ENV-linux$Processor.tar.xz || exit 8
  317. echo "$(tput sgr 0)"
  318. fi
  319. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" && ! -e "../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  320. echo "$(tput setaf 6)Unzipping Linux $Processor Arduino IDE portable...$(tput setaf 2)"
  321. sleep 2
  322. tar -xvf arduino-$ARDUINO_ENV-linux$Processor.tar.xz -C ../PF-build-env-$BUILD_ENV/ || exit 9
  323. mv ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor
  324. echo "# arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/arduino-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  325. echo "$(tput sgr0)"
  326. fi
  327. fi
  328. # Make Arduino IDE portable
  329. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/ ]; then
  330. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/
  331. fi
  332. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/ ]; then
  333. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable
  334. fi
  335. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output/ ]; then
  336. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/output
  337. fi
  338. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/ ]; then
  339. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages
  340. fi
  341. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/ ]; then
  342. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook
  343. fi
  344. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries/ ]; then
  345. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/sketchbook/libraries
  346. fi
  347. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging/ ]; then
  348. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/staging
  349. fi
  350. # Change Arduino IDE preferences
  351. if [ ! -e ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt ]; then
  352. echo "$(tput setaf 6)Setting $ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor Arduino IDE preferences for portable GUI usage...$(tput setaf 2)"
  353. sleep 2
  354. echo "update.check"
  355. sed -i 's/update.check = true/update.check = false/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  356. echo "board"
  357. sed -i "s/board = uno/board = $BOARD/g" ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  358. echo "editor.linenumbers"
  359. sed -i 's/editor.linenumbers = false/editor.linenumbers = true/g' ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  360. echo "boardsmanager.additional.urls"
  361. echo "boardsmanager.additional.urls=$BOARD_URL" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  362. echo "build.verbose=true" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  363. echo "compiler.cache_core=false" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  364. echo "compiler.warning_level=all" >>../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/lib/preferences.txt
  365. echo "# Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor" >> ../PF-build-env-$BUILD_ENV/Preferences-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  366. echo "$(tput sgr0)"
  367. fi
  368. # Download and extract Prusa Firmware related parts
  369. # Download and extract PrusaResearchRambo board
  370. if [ ! -f "$BOARD_FILENAME-$BOARD_VERSION.tar.bz2" ]; then
  371. echo "$(tput setaf 6)Downloading Prusa Research AVR MK3 RAMBo EINSy build environment...$(tput setaf 2)"
  372. sleep 2
  373. wget $BOARD_FILE_URL || exit 10
  374. fi
  375. if [[ ! -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION" || ! -e "../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]]; then
  376. echo "$(tput setaf 6)Unzipping $BOARD_PACKAGE_NAME Arduino IDE portable...$(tput setaf 2)"
  377. sleep 2
  378. tar -xvf $BOARD_FILENAME-$BOARD_VERSION.tar.bz2 -C ../PF-build-env-$BUILD_ENV/ || exit 11
  379. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  380. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  381. fi
  382. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME ]; then
  383. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME
  384. fi
  385. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware ]; then
  386. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware
  387. fi
  388. if [ ! -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr ]; then
  389. mkdir ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr
  390. fi
  391. mv ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$BOARD_VERSION ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/$BOARD_PACKAGE_NAME/hardware/avr/$BOARD_VERSION
  392. echo "# $BOARD_FILENAME-$BOARD_VERSION" >> ../PF-build-env-$BUILD_ENV/$BOARD_FILENAME-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  393. echo "$(tput sgr 0)"
  394. fi
  395. # Download and extract Prusa Firmware specific library files
  396. if [ ! -f "PF-build-env-WinLin-$BUILD_ENV.zip" ]; then
  397. echo "$(tput setaf 6)Downloading Prusa Firmware build environment...$(tput setaf 2)"
  398. sleep 2
  399. wget $PF_BUILD_FILE_URL || exit 12
  400. echo "$(tput sgr 0)"
  401. fi
  402. if [ ! -e "../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt" ]; then
  403. echo "$(tput setaf 6)Unzipping Prusa Firmware build environment...$(tput setaf 2)"
  404. sleep 2
  405. unzip -o PF-build-env-WinLin-$BUILD_ENV.zip -d ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 13
  406. echo "# PF-build-env-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  407. echo "$(tput sgr0)"
  408. fi
  409. # Check if User updated Arduino IDE 1.8.5 boardsmanager and tools
  410. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools" ]; then
  411. echo "$(tput setaf 6)Arduino IDE boards / tools have been manually updated...$"
  412. echo "Please don't update the 'Arduino AVR boards' as this will prevent running this script (tput setaf 2)"
  413. sleep 2
  414. fi
  415. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2" ]; then
  416. echo "$(tput setaf 6)PrusaReasearch compatible tools have been manually updated...$(tput setaf 2)"
  417. sleep 2
  418. echo "$(tput setaf 6)Copying Prusa Firmware build environment to manually updated boards / tools...$(tput setaf 2)"
  419. sleep 2
  420. cp -f ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/hardware/tools/avr/avr/lib/ldscripts/avr6.xn ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/4.9.2-atmel3.5.4-arduino2/avr/lib/ldscripts/avr6.xn
  421. echo "# PF-build-env-portable-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor-$BUILD_ENV" >> ../PF-build-env-$BUILD_ENV/PF-build-env-portable-$BUILD_ENV-$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor.txt
  422. echo "$(tput sgr0)"
  423. fi
  424. if [ -d "../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor/portable/packages/arduino/tools/avr-gcc/5.4.0-atmel3.6.1-arduino2" ]; then
  425. echo "$(tput setaf 1)Arduino IDE tools have been updated manually to a non supported version!!!"
  426. echo "Delete ../PF-build-env-$BUILD_ENV and start the script again"
  427. echo "Script will not continue until this have been fixed $(tput setaf 2)"
  428. sleep 2
  429. echo "$(tput sgr0)"
  430. exit 14
  431. fi
  432. #### End prepare building
  433. #### Start
  434. cd $SCRIPT_PATH
  435. # Check if git is available
  436. if type git > /dev/null; then
  437. git_available="1"
  438. fi
  439. while getopts b:c:d:g:l:m:n:o:p:v:?h flag
  440. do
  441. case "${flag}" in
  442. b) build_flag=${OPTARG};;
  443. c) clean_flag=${OPTARG};;
  444. d) devel_flag=${OPTARG};;
  445. g) graphics_flag=${OPTARG};;
  446. h) help_flag=1;;
  447. l) language_flag=${OPTARG};;
  448. m) mk404_flag=${OPTARG};;
  449. n) new_build_flag=${OPTARG};;
  450. o) output_flag=${OPTARG};;
  451. p) prusa_flag=${OPTARG};;
  452. v) variant_flag=${OPTARG};;
  453. ?) help_flag=1;;
  454. esac
  455. done
  456. #echo "variant_flag: $variant_flag";
  457. #echo "language_flag: $language_flag";
  458. #echo "devel_flag: $devel_flag";
  459. #echo "build_flag: $build_flag";
  460. #echo "output_flag: $output_flag";
  461. #echo "help_flag: $help_flag"
  462. #echo "clean_flag: $clean_flag"
  463. #echo "prusa_flag: $prusa_flag"
  464. #echo "new_build_flag: $new_build_flag"
  465. #
  466. # '?' 'h' argument usage and help
  467. if [ "$help_flag" == "1" ] ; then
  468. echo "***************************************"
  469. echo "* PF-build.sh Version: 1.0.6-Build_33 *"
  470. echo "***************************************"
  471. echo "Arguments:"
  472. echo "$(tput setaf 2)-b$(tput sgr0) Build/commit number '$(tput setaf 2)Auto$(tput sgr0)' needs git or a number"
  473. echo "$(tput setaf 2)-c$(tput sgr0) Do not clean up lang build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  474. echo "$(tput setaf 2)-d$(tput sgr0) Devel build '$(tput setaf 2)GOLD$(tput sgr0)', '$(tput setaf 2)RC$(tput sgr0)', '$(tput setaf 2)BETA$(tput sgr0)', '$(tput setaf 2)ALPHA$(tput sgr0)', '$(tput setaf 2)DEBUG$(tput sgr0)', '$(tput setaf 2)DEVEL$(tput sgr0)' and '$(tput setaf 2)UNKNOWN$(tput sgr0)'"
  475. echo "$(tput setaf 2)-g$(tput sgr0) Start MK404 grafics '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' lite '$(tput setaf 2)2$(tput sgr0)' fancy"
  476. echo "$(tput setaf 2)-l$(tput sgr0) Languages '$(tput setaf 2)ALL$(tput sgr0)' for multi language or '$(tput setaf 2)EN_ONLY$(tput sgr0)' for English only"
  477. echo "$(tput setaf 2)-m$(tput sgr0) Start MK404 sim '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes '$(tput setaf 2)2$(tput sgr0)' with MMU2"
  478. echo "$(tput setaf 2)-n$(tput sgr0) New fresh build '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  479. echo "$(tput setaf 2)-o$(tput sgr0) Output '$(tput setaf 2)1$(tput sgr0)' force or '$(tput setaf 2)0$(tput sgr0)' block output and delays"
  480. echo "$(tput setaf 2)-p$(tput sgr0) Keep Configuration_prusa.h '$(tput setaf 2)0$(tput sgr0)' no '$(tput setaf 2)1$(tput sgr0)' yes"
  481. echo "$(tput setaf 2)-v$(tput sgr0) Variant '$(tput setaf 2)All$(tput sgr0)' or variant file name"
  482. echo "$(tput setaf 2)-?$(tput sgr0) Help"
  483. echo "$(tput setaf 2)-h$(tput sgr0) Help"
  484. echo
  485. echo "Brief USAGE:"
  486. echo " $(tput setaf 2)./PF-build.sh$(tput sgr0) [-b] [-c] [-d] [-g] [-h] [-l] [-m] [-n] [-o] [-p] [-v] [-?]"
  487. echo
  488. echo "Example:"
  489. echo " $(tput setaf 2)./PF-build.sh -v All -l ALL -d GOLD$(tput sgr0)"
  490. echo " Will build all variants as multi language and final GOLD version"
  491. echo
  492. echo " $(tput setaf 2) ./PF-build.sh -v 1_75mm_MK3S-EINSy10a-E3Dv6full.h -b Auto -l ALL -d GOLD -o 1 -c 1 -p 1 -n 1$(tput sgr0)"
  493. echo " Will build MK3S multi language final GOLD firmware "
  494. echo " with current commit count number and output extra information,"
  495. echo " not delete lang build temporary files, keep Configuration_prusa.h and build with new fresh build folder."
  496. echo
  497. exit 21
  498. fi
  499. #
  500. # '-v' argument defines which variant of the Prusa Firmware will be compiled
  501. if [ -z "$variant_flag" ] ; then
  502. # Select which variant of the Prusa Firmware will be compiled, like
  503. PS3="Select a variant: "
  504. while IFS= read -r -d $'\0' f; do
  505. options[i++]="$f"
  506. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  507. select opt in "${options[@]}" "All" "Quit"; do
  508. case $opt in
  509. *.h)
  510. VARIANT=$(basename "$opt" ".h")
  511. VARIANTS[i++]="$opt"
  512. break
  513. ;;
  514. "All")
  515. VARIANT="All"
  516. VARIANTS=${options[*]}
  517. break
  518. ;;
  519. "Quit")
  520. echo "You chose to stop"
  521. exit 22
  522. ;;
  523. *)
  524. echo "$(tput setaf 1)This is not a valid variant$(tput sgr0)"
  525. ;;
  526. esac
  527. done
  528. else
  529. if [ -f "$SCRIPT_PATH/Firmware/variants/$variant_flag" ] ; then
  530. VARIANTS=$variant_flag
  531. elif [ "$variant_flag" == "All" ] ; then
  532. while IFS= read -r -d $'\0' f; do
  533. options[i++]="$f"
  534. done < <(find Firmware/variants/ -maxdepth 1 -type f -name "*.h" -print0 )
  535. VARIANT="All"
  536. VARIANTS=${options[*]}
  537. else
  538. echo "$(tput setaf 1)Argument $variant_flag could not be found in Firmware/variants please choose a valid one.$(tput sgr0)"
  539. echo "Only $(tput setaf 2)'All'$(tput sgr0) and file names below are allowed as variant '-v' argument.$(tput setaf 2)"
  540. ls -1 $SCRIPT_PATH/Firmware/variants/*.h | xargs -n1 basename
  541. echo "$(tput sgr0)"
  542. exit 23
  543. fi
  544. fi
  545. #'-l' argument defines if it is an English only version. Known values EN_ONLY / ALL
  546. #Check default language mode
  547. MULTI_LANGUAGE_CHECK=$(grep --max-count=1 "^#define LANG_MODE *" $SCRIPT_PATH/Firmware/config.h|sed -e's/ */ /g'|cut -d ' ' -f3)
  548. if [ -z "$language_flag" ] ; then
  549. PS3="Select a language: "
  550. echo
  551. echo "Which lang-build do you want?"
  552. select yn in "Multi languages" "English only"; do
  553. case $yn in
  554. "Multi languages")
  555. LANGUAGES="ALL"
  556. break
  557. ;;
  558. "English only")
  559. LANGUAGES="EN_ONLY"
  560. break
  561. ;;
  562. *)
  563. echo "$(tput setaf 1)This is not a valid language$(tput sgr0)"
  564. ;;
  565. esac
  566. done
  567. else
  568. if [[ "$language_flag" == "ALL" || "$language_flag" == "EN_ONLY" ]] ; then
  569. LANGUAGES=$language_flag
  570. else
  571. echo "$(tput setaf 1)Language argument is wrong!$(tput sgr0)"
  572. echo "Only $(tput setaf 2)'ALL'$(tput sgr0) or $(tput setaf 2)'EN_ONLY'$(tput sgr0) are allowed as language '-l' argument!"
  573. exit 24
  574. fi
  575. fi
  576. #Check if DEV_STATUS is selected via argument '-d'
  577. if [ ! -z "$devel_flag" ] ; then
  578. if [[ "$devel_flag" == "GOLD" || "$devel_flag" == "RC" || "$devel_flag" == "BETA" || "$devel_flag" == "ALPHA" || "$devel_flag" == "DEVEL" || "$devel_flag" == "DEBUG" || "$devel_flag" == "UNKNOWN" ]] ; then
  579. DEV_STATUS_SELECTED=$devel_flag
  580. else
  581. echo "$(tput setaf 1)Development argument is wrong!$(tput sgr0)"
  582. echo "Only $(tput setaf 2)'GOLD', 'RC', 'BETA', 'ALPHA', 'DEVEL', 'DEBUG' or 'UNKNOWN' $(tput sgr0) are allowed as devel '-d' argument!$(tput sgr0)"
  583. exit 25
  584. fi
  585. fi
  586. #Check if Build is selected via argument '-b'
  587. if [ ! -z "$build_flag" ] ; then
  588. if [[ "$build_flag" == "Auto" && "$git_available" == "1" ]] ; then
  589. echo "Build changed to $build_flag"
  590. BUILD=$(git rev-list --count HEAD)
  591. elif [[ $build_flag =~ ^[0-9]+$ ]] ; then
  592. BUILD=$build_flag
  593. else
  594. echo "$(tput setaf 1)Build number argument is wrong!$(tput sgr0)"
  595. echo "Only $(tput setaf 2)'Auto' (git needed) or numbers $(tput sgr0) are allowed as build '-b' argument!$(tput sgr0)"
  596. exit 26
  597. fi
  598. echo "New Build number is: $BUILD"
  599. fi
  600. # check if script has been started with arguments
  601. if [[ "$#" -eq "0" || "$output_flag" == 1 ]] ; then
  602. OUTPUT=1
  603. else
  604. OUTPUT=0
  605. fi
  606. #echo "Output is:" $OUTPUT
  607. #Check git branch has changed
  608. if [ ! -z "git_available" ]; then
  609. BRANCH=""
  610. CLEAN_PF_FW_BUILD=0
  611. else
  612. BRANCH=$(git branch --show-current)
  613. echo "Current branch is:" $BRANCH
  614. if [ ! -f "$SCRIPT_PATH/../PF-build.branch" ]; then
  615. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  616. echo "created PF-build.branch file"
  617. else
  618. PRE_BRANCH=$(cat "$SCRIPT_PATH/../PF-build.branch")
  619. echo "Previous branch was:" $PRE_BRANCH
  620. if [ ! "$BRANCH" == "$PRE_BRANCH" ] ; then
  621. CLEAN_PF_FW_BUILD=1
  622. echo "$BRANCH" >| $SCRIPT_PATH/../PF-build.branch
  623. fi
  624. fi
  625. fi
  626. #Set BUILD_ENV_PATH
  627. cd ../PF-build-env-$BUILD_ENV/$ARDUINO_ENV-$BOARD_VERSION-$TARGET_OS-$Processor || exit 27
  628. BUILD_ENV_PATH="$( pwd -P )"
  629. cd ../..
  630. #Checkif BUILD_PATH exists and if not creates it
  631. if [ ! -d "Prusa-Firmware-build" ]; then
  632. mkdir Prusa-Firmware-build || exit 28
  633. fi
  634. #Set the BUILD_PATH for Arduino IDE
  635. cd Prusa-Firmware-build || exit 29
  636. BUILD_PATH="$( pwd -P )"
  637. #Check git branch has changed
  638. if [ "$CLEAN_PF_FW_BUILD" == "1" ]; then
  639. read -t 10 -p "Branch changed, cleaning Prusa-Firmware-build folder"
  640. rm -r *
  641. else
  642. echo "Nothing to clean up"
  643. fi
  644. for v in ${VARIANTS[*]}
  645. do
  646. VARIANT=$(basename "$v" ".h")
  647. PRINTER=$(grep --max-count=1 "\bPRINTER_TYPE\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3 | cut -d '_' -f2)
  648. # Find firmware version in Configuration.h file and use it to generate the hex filename
  649. FW=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g')
  650. if [ -z "$BUILD" ] ; then
  651. # Find build version in Configuration.h file and use it to generate the hex filename
  652. BUILD=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  653. else
  654. # Find and replace build version in Configuration.h file
  655. BUILD_ORG=$(grep --max-count=1 "\bFW_COMMIT_NR\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d ' ' -f3)
  656. echo "Original build number: $BUILD_ORG"
  657. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD/g" $SCRIPT_PATH/Firmware/Configuration.h
  658. fi
  659. # Check if the motherboard is an EINSY and if so only one hex file will generated
  660. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  661. # Check development status
  662. DEV_CHECK=$(grep --max-count=1 "\bFW_VERSION\b" $SCRIPT_PATH/Firmware/Configuration.h | sed -e's/ */ /g'|cut -d '"' -f2|sed 's/\.//g'|cut -d '-' -f2)
  663. if [ -z "$DEV_STATUS_SELECTED" ] ; then
  664. if [[ "$DEV_CHECK" == *"RC"* ]] ; then
  665. DEV_STATUS="RC"
  666. elif [[ "$DEV_CHECK" == "ALPHA" ]]; then
  667. DEV_STATUS="ALPHA"
  668. elif [[ "$DEV_CHECK" == "BETA" ]]; then
  669. DEV_STATUS="BETA"
  670. elif [[ "$DEV_CHECK" == "DEVEL" ]]; then
  671. DEV_STATUS="DEVEL"
  672. elif [[ "$DEV_CHECK" == "DEBUG" ]]; then
  673. DEV_STATUS="DEBUG"
  674. else
  675. DEV_STATUS="UNKNOWN"
  676. echo
  677. echo "$(tput setaf 5)DEV_STATUS is UNKNOWN. Do you wish to set DEV_STATUS to GOLD?$(tput sgr0)"
  678. PS3="Select YES only if source code is tested and trusted: "
  679. select yn in "Yes" "No"; do
  680. case $yn in
  681. Yes)
  682. DEV_STATUS="GOLD"
  683. DEV_STATUS_SELECTED="GOLD"
  684. break
  685. ;;
  686. No)
  687. DEV_STATUS="UNKNOWN"
  688. DEV_STATUS_SELECTED="UNKNOWN"
  689. break
  690. ;;
  691. *)
  692. echo "$(tput setaf 1)This is not a valid DEV_STATUS$(tput sgr0)"
  693. ;;
  694. esac
  695. done
  696. fi
  697. else
  698. DEV_STATUS=$DEV_STATUS_SELECTED
  699. fi
  700. #Prepare hex files folders
  701. if [ ! -d "$SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD" ]; then
  702. mkdir -p $SCRIPT_PATH/../PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD || exit 30
  703. fi
  704. OUTPUT_FOLDER="PF-build-hex/FW$FW-Build$BUILD/$MOTHERBOARD"
  705. #Check if exactly the same hexfile already exists
  706. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex" && "$LANGUAGES" == "ALL" ]]; then
  707. echo ""
  708. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex | xargs -n1 basename
  709. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  710. if [ $OUTPUT == "1" ] ; then
  711. read -t 10 -p "Press Enter to continue..."
  712. fi
  713. elif [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex" && "$LANGUAGES" == "EN_ONLY" ]]; then
  714. echo ""
  715. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex | xargs -n1 basename
  716. echo "$(tput setaf 6)This hex file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  717. if [ $OUTPUT == "1" ] ; then
  718. read -t 10 -p "Press Enter to continue..."
  719. fi
  720. fi
  721. if [[ -f "$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip" && "$LANGUAGES" == "ALL" ]]; then
  722. echo ""
  723. ls -1 $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip | xargs -n1 basename
  724. echo "$(tput setaf 6)This zip file to be compiled already exists! To cancel this process press CRTL+C and rename existing hex file.$(tput sgr 0)"
  725. if [ $OUTPUT == "1" ] ; then
  726. read -t 10 -p "Press Enter to continue..."
  727. fi
  728. fi
  729. #List some useful data
  730. echo "$(tput setaf 2)$(tput setab 7) "
  731. echo "Printer :" $PRINTER
  732. echo "Variant :" $VARIANT
  733. echo "Firmware :" $FW
  734. echo "Build # :" $BUILD
  735. echo "Dev Check :" $DEV_CHECK
  736. echo "DEV Status :" $DEV_STATUS
  737. echo "Motherboard:" $MOTHERBOARD
  738. echo "Languages :" $LANGUAGES
  739. echo "Hex-file Folder:" $OUTPUT_FOLDER
  740. echo "$(tput sgr0)"
  741. #Prepare Firmware to be compiled by copying variant as Configuration_prusa.h
  742. if [ ! -f "$SCRIPT_PATH/Firmware/Configuration_prusa.h" ]; then
  743. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  744. else
  745. echo "$(tput setaf 6)Configuration_prusa.h already exist it will be overwritten in 10 seconds by the chosen variant.$(tput sgr 0)"
  746. if [ $OUTPUT == "1" ] ; then
  747. read -t 10 -p "Press Enter to continue..."
  748. fi
  749. cp -f $SCRIPT_PATH/Firmware/variants/$VARIANT.h $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 31
  750. fi
  751. #Prepare Configuration.h to use the correct FW_DEV_VERSION to prevent LCD messages when connecting with OctoPrint
  752. sed -i -- "s/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/g" $SCRIPT_PATH/Firmware/Configuration.h
  753. # set FW_REPOSITORY
  754. sed -i -- 's/#define FW_REPOSITORY "Unknown"/#define FW_REPOSITORY "Prusa3d"/g' $SCRIPT_PATH/Firmware/Configuration.h
  755. #Prepare English only or multi-language version to be build
  756. if [ $LANGUAGES == "EN_ONLY" ]; then
  757. echo " "
  758. echo "English only language firmware will be built"
  759. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE 0/g" $SCRIPT_PATH/Firmware/config.h
  760. echo " "
  761. else
  762. echo " "
  763. echo "Multi-language firmware will be built"
  764. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE 1/g" $SCRIPT_PATH/Firmware/config.h
  765. echo " "
  766. fi
  767. #Check if compiler flags are set to Prusa specific needs for the rambo board.
  768. #if [ $TARGET_OS == "windows" ]; then
  769. #RAMBO_PLATFORM_FILE="PrusaResearchRambo/avr/platform.txt"
  770. #fi
  771. #New fresh PF-Firmware-build
  772. if [ "$new_build_flag" == "1" ]; then
  773. rm -r -f $BUILD_PATH/* || exit 54
  774. fi
  775. #### End of Prepare building
  776. #### Start building
  777. export ARDUINO=$BUILD_ENV_PATH
  778. #echo $BUILD_ENV_PATH
  779. #export BUILDER=$ARDUINO/arduino-builder
  780. echo
  781. #read -t 5 -p "Press Enter..."
  782. echo
  783. echo "Start to build Prusa Firmware ..."
  784. echo "Using variant $VARIANT$(tput setaf 3)"
  785. if [ $OUTPUT == "1" ] ; then
  786. sleep 2
  787. fi
  788. #$BUILD_ENV_PATH/arduino-builder -dump-prefs -debug-level 10 -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 41
  789. $BUILD_ENV_PATH/arduino-builder -compile -hardware $ARDUINO/hardware -hardware $ARDUINO/portable/packages -tools $ARDUINO/tools-builder -tools $ARDUINO/hardware/tools/avr -tools $ARDUINO/portable/packages -built-in-libraries $ARDUINO/libraries -libraries $ARDUINO/portable/sketchbook/libraries -fqbn=$BOARD_PACKAGE_NAME:avr:$BOARD -build-path=$BUILD_PATH -warnings=all $SCRIPT_PATH/Firmware/Firmware.ino || exit 42
  790. echo "$(tput sgr 0)"
  791. if [ $LANGUAGES == "ALL" ]; then
  792. echo "$(tput setaf 2)"
  793. echo "Building multi language firmware" $MULTI_LANGUAGE_CHECK
  794. echo "$(tput sgr 0)"
  795. if [ $OUTPUT == "1" ] ; then
  796. sleep 2
  797. fi
  798. cd $SCRIPT_PATH/lang
  799. echo "$(tput setaf 3)"
  800. ./config.sh || exit 43
  801. echo "$(tput sgr 0)"
  802. # Check if previous languages and firmware build exist and if so clean them up
  803. if [ -f "lang_en.tmp" ]; then
  804. echo ""
  805. echo "$(tput setaf 6)Previous lang build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  806. if [ $OUTPUT == "1" ] ; then
  807. read -t 10 -p "Press Enter to continue..."
  808. fi
  809. echo "$(tput setaf 3)"
  810. ./lang-clean.sh
  811. echo "$(tput sgr 0)"
  812. fi
  813. if [ -f "progmem.out" ]; then
  814. echo ""
  815. echo "$(tput setaf 6)Previous firmware build files already exist these will be cleaned up in 10 seconds.$(tput sgr 0)"
  816. if [ $OUTPUT == "1" ] ; then
  817. read -t 10 -p "Press Enter to continue..."
  818. fi
  819. echo "$(tput setaf 3)"
  820. ./fw-clean.sh
  821. echo "$(tput sgr 0)"
  822. fi
  823. # build languages
  824. echo "$(tput setaf 3)"
  825. ./lang-build.sh || exit 44
  826. # build community languages
  827. ./lang-community.sh || exit 45
  828. # Combine compiled firmware with languages
  829. ./fw-build.sh || exit 46
  830. cp not_tran.txt not_tran_$VARIANT.txt
  831. cp not_used.txt not_used_$VARIANT.txt
  832. echo "$(tput sgr 0)"
  833. # Check if the motherboard is an EINSY and if so only one hex file will generated
  834. MOTHERBOARD=$(grep --max-count=1 "\bMOTHERBOARD\b" $SCRIPT_PATH/Firmware/variants/$VARIANT.h | sed -e's/ */ /g' |cut -d ' ' -f3)
  835. # If the motherboard is an EINSY just copy one hexfile
  836. if [ "$MOTHERBOARD" = "BOARD_EINSY_1_0a" ]; then
  837. echo "$(tput setaf 2)Copying multi language firmware for MK3/Einsy board to PF-build-hex folder$(tput sgr 0)"
  838. # Make a copy of "lang.bin" for MK404 MK3 and MK3S
  839. if [ ! -z "$mk404_flag" ]; then
  840. cp -f lang.bin $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin
  841. fi
  842. # End of "lang.bin" for MK3 and MK3S copy
  843. cp -f firmware.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  844. else
  845. echo "$(tput setaf 2)Zip multi language firmware for MK2.5/miniRAMbo board to PF-build-hex folder$(tput sgr 0)"
  846. cp -f firmware_cz.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-cz.hex
  847. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-de.hex
  848. cp -f firmware_es.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-es.hex
  849. cp -f firmware_fr.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-fr.hex
  850. cp -f firmware_it.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-it.hex
  851. cp -f firmware_pl.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-pl.hex
  852. if [ $TARGET_OS == "windows" ]; then
  853. zip a $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  854. rm $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  855. elif [ $TARGET_OS == "linux" ]; then
  856. # Make a copy for MK404 sim of MK2, MK2.5, MK2.5S firmware
  857. if [ ! -z "$mk404_flag" ]; then
  858. cp -f firmware_de.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  859. fi
  860. # End of MK2, MK2.5, MK2.5S firmware copy
  861. zip -m -j ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.zip ../../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-??.hex
  862. fi
  863. fi
  864. # Cleanup after build
  865. if [[ -z "$clean_flag" || "$clean_flag" == "0" ]]; then
  866. echo "$(tput setaf 3)"
  867. ./fw-clean.sh || exit 51
  868. ./lang-clean.sh || exit 52
  869. echo "$(tput sgr 0)"
  870. fi
  871. else
  872. echo "$(tput setaf 2)Copying English only firmware to PF-build-hex folder$(tput sgr 0)"
  873. cp -f $BUILD_PATH/Firmware.ino.hex $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex || exit 47
  874. fi
  875. # Cleanup Firmware
  876. if [[ -z "$prusa_flag" || "$prusa_flag" == "0" ]]; then
  877. rm $SCRIPT_PATH/Firmware/Configuration_prusa.h || exit 53
  878. fi
  879. # Delete dupblicates
  880. if find $SCRIPT_PATH/lang/ -name '*RAMBo10a*.txt' -printf 1 -quit | grep -q 1
  881. then
  882. rm $SCRIPT_PATH/lang/*RAMBo10a*.txt
  883. fi
  884. # MK2 not supported in this branch
  885. if find $SCRIPT_PATH/lang/ -name '*MK2-RAMBo13a*' -printf 1 -quit | grep -q 1
  886. then
  887. rm $SCRIPT_PATH/lang/*MK2-RAMBo13a*.txt
  888. fi
  889. if find $SCRIPT_PATH/lang/ -name 'not_tran.txt' -printf 1 -quit | grep -q 1
  890. then
  891. rm $SCRIPT_PATH/lang/not_tran.txt
  892. fi
  893. if find $SCRIPT_PATH/lang/ -name 'not_used.txt' -printf 1 -quit | grep -q 1
  894. then
  895. rm $SCRIPT_PATH/lang/not_used.txt
  896. fi
  897. #New fresh PF-Firmware-build
  898. if [ "$new_build_flag" == "1" ]; then
  899. rm -r -f $BUILD_PATH/* || exit 54
  900. fi
  901. # Restore files to previous state
  902. sed -i -- "s/^#define FW_DEV_VERSION FW_VERSION_$DEV_STATUS/#define FW_DEV_VERSION FW_VERSION_UNKNOWN/g" $SCRIPT_PATH/Firmware/Configuration.h
  903. sed -i -- 's/^#define FW_REPOSITORY "Prusa3d"/#define FW_REPOSITORY "Unknown"/g' $SCRIPT_PATH/Firmware/Configuration.h
  904. if [ ! -z "$BUILD_ORG" ] ; then
  905. sed -i -- "s/^#define FW_COMMIT_NR.*/#define FW_COMMIT_NR $BUILD_ORG/g" $SCRIPT_PATH/Firmware/Configuration.h
  906. fi
  907. echo $MULTI_LANGUAGE_CHECK
  908. #sed -i -- "s/^#define LANG_MODE * /#define LANG_MODE $MULTI_LANGUAGE_CHECK/g" $SCRIPT_PATH/Firmware/config.h
  909. sed -i -- "s/^#define LANG_MODE *1/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  910. sed -i -- "s/^#define LANG_MODE *0/#define LANG_MODE ${MULTI_LANGUAGE_CHECK}/g" $SCRIPT_PATH/Firmware/config.h
  911. if [ $OUTPUT == "1" ] ; then
  912. sleep 5
  913. fi
  914. done
  915. # Switch to hex path and list build files
  916. cd $SCRIPT_PATH
  917. echo "$(tput setaf 2) "
  918. echo " "
  919. echo "Build done, please use Slic3rPE > 1.41.0 to upload the firmware"
  920. echo "more information how to flash firmware https://www.prusa3d.com/drivers/ $(tput sgr 0)"
  921. #### End building
  922. #### MK404 Simulator
  923. # Check/compile MK404 sim
  924. if [ ! -z "$mk404_flag" ]; then
  925. ./MK404-build.sh -c1 || exit 61
  926. # For Prusa MK2, MK2.5/S
  927. if [ "$MOTHERBOARD" == "BOARD_RAMBO_MINI_1_3" ]; then
  928. PRINTER="${PRINTER}_mR13"
  929. else
  930. if [[ "$mk404_flag" == "2" || "$mk404_flag" == "MMU2" || "$mk404_flag" == "MMU2S" ]]; then # Check if MMU2 is selected only for MK3/S
  931. PRINTER="${PRINTER}MMU2"
  932. fi
  933. fi
  934. # Run MK404 with grafics
  935. if [ ! -z "$graphics_flag" ]; then
  936. MK404_options="--colour-extrusion --extrusion Quad_HR -g "
  937. if [[ "$graphics_flag" == "1" || "$graphics_flag" == "lite" ]]; then
  938. MK404_options="${MK404_options}lite"
  939. elif [[ "$graphics_flag" == "2" || "$graphics_flag" == "fancy" ]]; then
  940. MK404_options="${MK404_options}fancy"
  941. else
  942. echo "$(tput setaf 1)Unsupported MK404 graphics option $graphics_flag$(tput sgr 0)"
  943. fi
  944. fi
  945. # Output some useful data
  946. echo "Printer: $PRINTER"
  947. echo "Options: $MK404_options"
  948. # Change to MK404 build folder
  949. cd ../MK404/master/build
  950. # Copy language bin file for MK3 and MK3S to xflash
  951. # if [ -f $SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin ]; then
  952. # echo "Copy 'FW$FW-Build$BUILD-$VARIANT-lang.bin' to 'Prusa_${PRINTER}_xflash.bin'"
  953. # dd if=/dev/zero bs=1 count=262145 | tr "\000" "\377" >Prusa_${PRINTER}_xflash.bin
  954. # dd if=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-lang.bin of=Prusa_${PRINTER}_xflash.bin conv=notrunc
  955. # fi
  956. #Decide which hex file to use EN_ONLY or Multi language
  957. if [ "$LANGUAGES" == "ALL" ]; then
  958. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT.hex
  959. else
  960. MK404_firmware_file=$SCRIPT_PATH/../$OUTPUT_FOLDER/FW$FW-Build$BUILD-$VARIANT-EN_ONLY.hex
  961. fi
  962. # Start MK404
  963. # default with serial output and terminal to manipulate it via terminal
  964. ./MK404 Prusa_$PRINTER -s --terminal $MK404_options -f $MK404_firmware_file || exit 62
  965. fi
  966. #### End of MK404 Simulator